/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	FTConfig.c

NAME
	FTConfig.c for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles configuring filters.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/****************************** FTConfig.c *******************************/


/*****************Includes */

#include "filter.h"
#include "filterInterface.h"
#include "auto-config.h"

/**************** globals *********************/

extern	FilterInfoStruct			*filters;
extern funcHdl						DevMarker;

void 				ConfigureFilter( short);


extern void			HandleNormalEvent( EventRecord *);
extern pascal OSErr	FilterDev (PBCallToFilter *);


/****************************** ConfigureFilter **********************************/

void ConfigureFilter( short theLine)
{
EventRecord		myEvent;
WindowPtr		theW;
short			wPart;
short			fRef;
char			done = 0;
state			s;
OSErr			resErr, err;
PBCallToFilter	pb;
GrafPtr			oldPort;
Boolean			isDevFilter, tempLoad, isAutoConfig;
Handle			fVLDh, tempfCFG;
long			cfgPtr;
FSSpec			devSpec;

	if( filters[theLine].filterConfigH == 0L)
	{
		ParamText("\pNo fCFG resource", "\pBetter Put one in", "\p", "\p");
		NoteAlert(128, (ProcPtr) nil);
		return;
	}


	GetPort(&oldPort);
	
	isDevFilter = FALSE;
	tempLoad = FALSE;
	isAutoConfig = FALSE;

	resErr = noErr;
	fRef = 0;
	
	if(filters[theLine].fINFrec.autoConfig == 0x00000001) 
		isAutoConfig = TRUE;
	
	if (filters[theLine].filterFunc != DevMarker) /* normal filter */
	{
		fRef = FSpOpenResFile( &filters[theLine].spec, fsCurPerm);
		resErr = ResError();
	}
	else
	{
		FSMakeFSSpec( 0L, filters[theLine].spec.parID, "\pFilterDev.Rsrc", &devSpec); 
		fRef = FSpOpenResFile( &devSpec, fsCurPerm);
		resErr = ResError();
		isDevFilter = TRUE;
	}
	
	if( (resErr == noErr && fRef != -1) )
	{
		pb.filterConfigH = filters[theLine].filterConfigH;	/* grab the old configH */
		HandToHand( &pb.filterConfigH);						/* make a copy of it to use */
		pb.dlg = GetNewDialog(128,0L,(WindowPtr) -1L);
		if(isAutoConfig) 
		{
			fVLDh = GetResource ('fVLD', 128 );
			HNoPurge( fVLDh);
		}

		if( pb.filterConfigH != 0L && pb.dlg != 0L)
		{
			if(isAutoConfig)
				cfgInit ( pb.dlg, pb.filterConfigH, fVLDh, &cfgPtr );
			else
			{
				pb.event = &myEvent;
				pb.serviceRequested = msgInitOptions;		/* init message */
				
				if( !isDevFilter)							/* normal filter */
				{
					if( filters[theLine].count == 0) 
					{
						filters[theLine].filterFunc = (funcHdl)GetResource(  'FILT', 128);
						resErr = ResError();
						if( filters[theLine].filterFunc != 0L ) 
						{
							DetachResource( (Handle)filters[theLine].filterFunc);
							MoveHHi( (Handle)filters[ theLine ].filterFunc);
							HLock( (Handle)filters[ theLine ].filterFunc);
						}
						tempLoad = TRUE;
					}
					err = (**filters[theLine].filterFunc)( &pb);
				}				
				else err = FilterDev( &pb);
			}
	
			do
			{
				WaitNextEvent(everyEvent, &myEvent, 0, nil);				

				if( myEvent.what == nullEvent)
				{
					if ( IsDialogEvent ( &myEvent ) )
					{
						if( isAutoConfig)
							done = s = cfgHandleEvent ( pb.dlg, &myEvent, cfgPtr );
						else
						{
							pb.serviceRequested = msgDialogEvent;
							if( !isDevFilter) err = (**filters[theLine].filterFunc)( &pb);
							else err = FilterDev( &pb);
							done = s = (char)pb.var5;
						}
					}
					HandleNormalEvent( &myEvent);
				}
				
				else if ( IsDialogEvent ( &myEvent ) )
					{
						if( isAutoConfig)
							done = s = cfgHandleEvent ( pb.dlg, &myEvent, cfgPtr );
						else
						{
							pb.serviceRequested = msgDialogEvent;
								if( !isDevFilter) err = (**filters[theLine].filterFunc)( &pb);
								else err = FilterDev( &pb);
							done = s = (char)pb.var5;
						}
					}
				
				else if (myEvent.what != mouseDown)
					HandleNormalEvent( &myEvent);
				else
				{	
					wPart = FindWindow ( myEvent.where, &theW );
					if( wPart == inDrag || wPart == inContent)
					{
						if (theW == pb.dlg )	// it's theD!
							if (wPart == inDrag)
								DragWindow ( pb.dlg, myEvent.where, &screenBits.bounds );
					}
					else HandleNormalEvent( &myEvent);
				}
			} while (!done);
		
			
			if( isAutoConfig)
				s = cfgFinish (pb.dlg, s, pb.filterConfigH, cfgPtr );
			else
			{
				pb.serviceRequested = msgCloseOptions;	/* close message */
				if( !isDevFilter) err = (**filters[theLine].filterFunc)( &pb);
				else err = FilterDev( &pb);
				s = (char)pb.var5;
			}
			
			if( tempLoad)
			{
				HUnlock( (Handle)filters[ theLine ].filterFunc);
				DisposHandle( (Handle)filters[theLine].filterFunc);
				filters[theLine].filterFunc = 0L;
			}

			if (s==cfgStSave)	// SAVE button
			{
				tempfCFG = GetResource( 'fCFG', 128);	
				SetHandleSize( tempfCFG, GetHandleSize( pb.filterConfigH));
				BlockMove( *pb.filterConfigH, *tempfCFG, GetHandleSize( tempfCFG) );
				ChangedResource(tempfCFG);
				if (ResError()==noErr)
					WriteResource ( tempfCFG );
			}

			if(s == cfgStOk || s == cfgStSave)
			{
				DisposHandle( (Handle)filters[theLine].filterConfigH);	/* out with the old */
				filters[theLine].filterConfigH = pb.filterConfigH;		/* in with the new */
			}
			else DisposHandle( (Handle)pb.filterConfigH);				/* or out with the new */

			DisposDialog(pb.dlg);
		}
		if(isAutoConfig) HPurge( fVLDh);
		CloseResFile( fRef);
	}
	SetPort(oldPort);
}


