/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Steve J in early 1992
	See the Modification History for more details

FILE
	filterTop.c

NAME
	filterTop.c for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains shell code.

MODIFICATION HISTORY
	Created by Steve J

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	Added Save menu support (save stub apps)
	
*/	

/* 
Note. Steve's FT 0.1 has been used as the shell to house the
filter interface engine.
This was done to make it easier to intergrate the filter interface
into the User Interface in the future.
All of steves shell is in this file. FilterTop.c.
You probably shouldnt bother reading thru this file as no doubt
steves shell had changed somewhat from FT 0.1 :)

The filter interface is presently hanging off the HandleNull routine.
Have a look at that. It fiddles 3 global pointers, myActiveFilterList,
theActiveFilter, nextActiveFilter. The first is the list of processes
that are currently active or idle, waiting to become active.
The second is a pointer to the process that currently has the processor.
The third is the next process to receive the processor.
The filter interface engine can be found in the file filters.c. Also
have a look at filter.h and filterInterface.h
*/


/****************************** FilterTop.c *******************************/

/*********************** includes */
#include <GestaltEqu.h>
#include <AppleEvents.h>

#include "defs.h"
#include "Prototypes.h"
#include "Globals.h"
#include "myAEevents.h"			/* patch to 0.1 */
#include "cursors.h"			/* patch to 0.1 */
#include "windowUtils.h"		/* patch to 0.1 */
#include "filter.h"				/* patch to 0.1 */
#include "filterInterface.h"	/* patch to 0.1 */
#include "zoom.h"				/* patch to 0.1 */
#include "prefs.h"				/* patch to 0.1 */
#include "stubApp.h"			/* patch to 0.1 */
#include "infoManager.h"		/* patch to 0.1 */


/*********** Patch to 0.1 Globals *********/

extern WindowPtr					gFilesWindow, gProcessWindow, gInfoWindow;
extern ListHandle					gFileList, gFilterList, gPipeList, gProcessList;
extern ControlHandle				gDeleteButton, gDeleteFiltersButton, gPipesButton;
extern struct ActiveFilterStruct	*myActiveFilterList, 
									*theActiveFilter, 
									*nextActiveFilter;
extern FilterInfoStruct				*filters;			/* funcHdl pointer table */


extern void 						ConfigureFilter( short);

short								LastListClicked;

/****************************/

main()
{
	ToolBoxInit();
	if( !CheckAEAvailable())							/* patch to 0.1 */	
	{			
		StopAlert( 400, 0L);	/* not system 7 */
		return;
	}
	GetPrefSpec();
	WindowSetup();
	RectSetup();
	MenuSetup();
	
	GetAppDir();										/* patch to 0.1 */
	FilterInit();
	FilterListSetup();									/* patch to 0.1 */
	AddFilters( gFilterList);
	InitMyCursors();									/* patch to 0.1 */
	SetupInfoWindow();
	ProcessWindowSetup();
	FileWindowSetup();									/* patch to 0.1 */
	if( InitAppleEvents() == noErr)	/* I'm not sure which errors here are fatal*/
		MainEventLoop();
	SaveWindowPositions();
}

void WindowSetup()
{
	ftWindow = GetNewWindow(DEFAULT_ID, nil, (WindowPtr) -1L);
	SetPort(ftWindow);
	RestoreWindowPos( ftWindow, 130);
	zoomport( ftWindow, 1);
	ShowWindow(ftWindow);
	SelectWindow(ftWindow);
	LastListClicked = 0;
}

void RectSetup()
{
    boundsRect = (*GetGrayRgn()) -> rgnBBox;
    
 	sizeRect = boundsRect;
	sizeRect.top = 50;
	sizeRect.left = 150;
	sizeRect.bottom -= 40;
}

void MenuSetup()
{
	Handle		ftMBar;
	OSErr		menuErr;
	short			index;
	Str255		helpString;
	
	ftMBar = GetNewMBar(DEFAULT_ID);
	SetMenuBar(ftMBar);
	
	appleMenu = GetMHandle(APPLE_MENU);
	AddResMenu(appleMenu, 'DRVR');
	
	prefsSubmenu = GetMenu(PREFS_SUBMENU);
	InsertMenu(prefsSubmenu, hierMenu);
	
	DrawMenuBar();
}

void ToolBoxInit()
{
	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs((ProcPtr) nil);
	InitCursor();
}


void MainEventLoop()
{
	while(done==false)
	{
		HandleEvent();
	}
}

void HandleEvent()
{
	EventRecord		myEvent;
	short			eventType, itemHit;
	Boolean			gotEvent, isDialogEvent, validHit;
	DialogPtr		hitDialog;

	gotEvent = WaitNextEvent(everyEvent, &myEvent, sleepTicks, currentRegion);
 		isDialogEvent = IsDialogEvent(&myEvent);
	
	if(gotEvent == true || myEvent.what == nullEvent) /* patch to 0.1 */
 		HandleNormalEvent( &myEvent);
}


void HandleNormalEvent( EventRecord *event)
{
	short	eventType;
	
 	eventType = event->what;
 	
 	switch(eventType)
 	{
 		case	keyDown:
 		case	autoKey:
 			
 				HandleKeyDown(event->message, event->modifiers);
 				break;
 					
 		case	mouseDown:
 			
 				HandleClick(event);
 				break;
 					
 		case	updateEvt:
 			
 				HandleUpdate((WindowPtr) event->message);
 				break;
 					
 		case	activateEvt:
 			
			HandleActivate((WindowPtr)event->message, 			/* patch 0.1 */
						(event->modifiers & activeFlag) != 0 );
 				break;
 					
 		case	osEvt:
 			
 				break;
 					
 		case	kHighLevelEvent:
 			
 				HandleHighLevelEvent( event); /* patch to 0.1 */
 				break;

 		case	nullEvent:
 			
 				HandleNull();
 				break;
 					
 	}
}




void HandleKeyDown( long key, short modifiers)
{
	if(modifiers & cmdKey)
		HandleMenu(MenuKey(key));
}	

void HandleMenu(long menuCode)
{
	short		thisMenu, thisItem;
	
	thisMenu = HiWord(menuCode);
	thisItem = LoWord(menuCode);
	
	switch(thisMenu)
	{
		case	APPLE_MENU:
		
				HandleApple(thisItem);
				break;
				
		case	FILE_MENU:
		
				HandleFile(thisItem);
				break;
			
		case	FILTERS_MENU:
		
				HandleFilters(thisItem);
				break;
				
		case	WINDOW_MENU:
		
				HandleWindow(thisItem);
				break;
				
	}
	HiliteMenu(0);
}
 	
void HandleApple( short thisItem)
{
	Str255		daName;
	
	switch(thisItem)
	{
		case	ABOUT_FILTERTOP:
		
				DoAbout();
				break;
				
		default:
				
				GetItem(appleMenu, thisItem, daName);
				OpenDeskAcc(daName);
				break;
	}
	HiliteMenu(0);
}

void HandleFile( short thisItem)
{
	switch(thisItem)
	{
		case	SAVE_ITEM:
				
				SavePipeLine();
				ArrowCursor();
				break;

		case	TRANSFORM_FILE:
		
				HandleTransform();
				break;

		case	GET_INFO:
		
				HandleInfo();
				break;

		case	QUIT:
				HandleQuit();
				break;
	}	
	HiliteMenu(0);	
}


/*------------------ HandleTransform -------------------*/
/*
	920302	Douglas Yarrington	(yarri@ee.eng.ohio-state.edu)
	
	I added the StandardGetFile call to allow files to
	be transformed via the File menu.
	
	This requires that MacTraps2 be added to ThinkC projects,
	and also requires system 7.
*/
void HandleTransform()
{
StandardFileReply	sfr;
	
	StandardGetFile(0L,-1,0L,&sfr);
	if (sfr.sfGood)		// Add the file to the pipelist
		MyOpenFile( &sfr.sfFile );
}
/*------------------ HandleTransform -------------------*/


void HandleQuit()
{
	HiliteMenu(FILE_MENU);
	done = true;
	HiliteMenu(0);
}


void HandleFilters( short thisItem)
{
	switch(thisItem)
	{
		case	2:
		
				HandleConfig();
				break;
				
	}
	HiliteMenu(0);
}


void HandleWindow( short thisItem)
{
	switch(thisItem)	/* patch to 0.1 */
	{
		case	1:
		zoomport( ftWindow, 1);
		ShowWindow( ftWindow);
		SelectWindow( ftWindow );
		break;
		
		case	2:
		zoomport( gFilesWindow, 1);
		ShowWindow( gFilesWindow);
		SelectWindow( gFilesWindow );
		break;
		
		case	3:
		zoomport( gProcessWindow, 1);
		ShowWindow( gProcessWindow);
		SelectWindow( gProcessWindow);
		break;
		
	}		
}


void HandleClick(EventRecord *myEvent)
{
	short			where;
	long		menuCode;
	WindowPtr	clickedWindow;
	
	where = FindWindow(myEvent->where, &clickedWindow);
	
	switch(where)
	{
		case	inMenuBar:
		
				menuCode = MenuSelect(myEvent->where);
				HandleMenu(menuCode);
				break;
				
		case	inSysWindow:
		
				SystemClick(myEvent, clickedWindow);
				break;
				
		case	inContent:
		
			if ( clickedWindow != FrontWindow())		/* Patch to 0.1 */
				SelectWindow( clickedWindow);
			else
				HandleContentClick( clickedWindow, myEvent);
				break;
				
		case	inDrag:
		
				SelectWindow(clickedWindow);    
				DragWindow(clickedWindow, myEvent->where, &boundsRect);
				break;
				
		case	inGoAway:
		
				HandleGoAway(clickedWindow, where, myEvent->where);
				break;
				
		case	inGrow:
		
				HandleGrow(clickedWindow, myEvent->where);
				break;
				
		case	inZoomIn:
		case	inZoomOut:
		
				HandleZoom(clickedWindow, where, myEvent->where);
				break;
	}
}

void HandleZoom( WindowPtr clickedWindow, short partCode, Point downHere)
{
	WindowPeek		wp;
	WStateData		*p;

	if(TrackBox(clickedWindow, downHere, partCode))
	{
		wp = (WindowPeek)clickedWindow;	/* set up limits so we only grow vertically */
		p = * (WStateData **) wp->dataHandle;
	 	(*p).stdState.left = (*p).userState.left;
	 	(*p).stdState.right = (*p).userState.right;
		EraseRect( &clickedWindow->portRect);
		ZoomWindow(clickedWindow, partCode, true);
		if( clickedWindow == gFilesWindow)		/* Patch to 0.1 */
		{
			AdjustWindowItems( clickedWindow);
			SetUpDeleteButton( clickedWindow);
		}
		else if( clickedWindow == gProcessWindow)		/* Patch to 0.1 */
		{
			AdjustWindowItems( clickedWindow);
		}
		else if( clickedWindow == ftWindow)
		{
			AdjustWindowItems( clickedWindow);
			SetUpFilterButtons( clickedWindow);
		}
	}
}

void HandleGoAway( WindowPtr clickedWindow, short partCode, Point downHere)
{
	Boolean		clickedBox;
	
	clickedBox = TrackBox(clickedWindow, downHere, partCode);
	if(clickedBox == true) 
	{
		zoomport( clickedWindow, 0);
		HideWindow(clickedWindow);
	}
}

void HandleGrow(WindowPtr thisWindow, Point clickedHere)
{
	long	location;
	short		h, v, tempGrowHeight;
	Rect		maxWindowRect;
	
 	maxWindowRect = screenBits.bounds;	/* set up limits so we only grow vertically */
 	maxWindowRect.top = 99;
 	maxWindowRect.left = thisWindow->portRect.right +1;
 	maxWindowRect.right = thisWindow->portRect.right +1;

	location = GrowWindow(thisWindow, clickedHere, &maxWindowRect);
	if ( location != 0)
	{
		EraseRect( &thisWindow->portRect);
		tempGrowHeight = HiWord( location);
		tempGrowHeight -= 15;
		tempGrowHeight = (tempGrowHeight / 18) * 18;
		tempGrowHeight += 15;
		SizeWindow( thisWindow, LoWord( location), 
					tempGrowHeight, TRUE);
	
		if( thisWindow == gFilesWindow)		/* Patch to 0.1 */
		{
			AdjustWindowItems( thisWindow);
			SetUpDeleteButton( thisWindow);
		}
		if( thisWindow == gProcessWindow)		/* Patch to 0.1 */
		{
			AdjustWindowItems( thisWindow);
		}
		else if( thisWindow == ftWindow)
		{
		 	maxWindowRect.left = thisWindow->portRect.right +1;
		 	maxWindowRect.right = thisWindow->portRect.right +1;
			AdjustWindowItems( thisWindow);
			SetUpFilterButtons ( thisWindow);
		}
		
		InvalRect(&thisWindow->portRect);
	}
}

void HandleUpdate(WindowPtr updateWindow)
{
	GrafPtr		oldPort;

	GetPort( &oldPort );		/* patch to 0.1 */
	SetPort( updateWindow );

	InvalRect(&updateWindow->portRect);

	BeginUpdate(updateWindow);
	EraseRect(&updateWindow->portRect);

	if(updateWindow == ftWindow)
	{
		DrawGrowIcon(ftWindow);
		DrawControls(ftWindow);
		TextFont( 0 );
		TextSize( 12 );
		LUpdate(ftWindow->visRgn, gFilterList);	/* patch 0.1 */
		LUpdate(ftWindow->visRgn, gPipeList);
	}
		
	if (updateWindow == gFilesWindow)	/* patch 0.1 */
	{
		
		DrawGrowIcon( gFilesWindow );
		DrawControls( gFilesWindow );
		TextFont( 0 );
		TextSize( 12 );
		LUpdate(gFilesWindow->visRgn, gFileList);
	}

	if (updateWindow == gProcessWindow)	/* patch 0.1 */
	{
		
		DrawGrowIcon( gProcessWindow );
		TextFont( 0 );
		TextSize( 12 );
		LUpdate(gProcessWindow->visRgn, gProcessList);
	}
	if (updateWindow == gInfoWindow)	/* patch 0.1 */
	{
		UpdateInfoWindow();
	}
	EndUpdate(updateWindow);
	SetPort( oldPort);
}

void HandleActivate(WindowPtr window, Boolean becomingActive)	/* patch to 0.1 */
{
	 GrafPtr	oldPort;
	 
	 if(becomingActive) SetCursor(&arrow);
	 
	 GetPort(&oldPort);
	if(window == ftWindow)
	{
		DrawGrowIcon(ftWindow);
		
		if ( becomingActive )
		{
			SetPort( ftWindow );
			LActivate(true, gFilterList);	/* patch to 0.1 */
			LActivate(true, gPipeList);	/* patch to 0.1 */
		}
		else
		{
			LActivate(false, gFilterList);
			LActivate(false, gPipeList);
		}
	}

	if (window == gFilesWindow)			/* patch to 0.1 */
	{		
		DrawGrowIcon( gFilesWindow );
		
		if ( becomingActive )
		{
			SetPort( gFilesWindow );
			LActivate(true, gFileList);
		}
		else
			LActivate(false, gFileList);
	}
	if (window == gProcessWindow)			/* patch to 0.1 */
	{		
		DrawGrowIcon( gProcessWindow );
		
		if ( becomingActive )
		{
			SetPort( gProcessWindow );
			LActivate(true, gProcessList);
		}
		else
			LActivate(false, gProcessList);
	}
	if (window == gInfoWindow)
	{
		ActivateInfoWindow( becomingActive);
	}
}

void HandleHighLevelEvent( event)	/* patch to 0.1*/
EventRecord		*event;
{
	AEProcessAppleEvent( event);
}

/********************************* HandleNull *************************/
/* patch to 0.1 -- do one loop thru the filter loop */

void HandleNull()
{
	Boolean gotOne, firstPass;
	
	gotOne = FALSE;
	firstPass = TRUE;
	
	if( myActiveFilterList != 0L)				/* only bother if there is an active filter */
	{	
		while(!gotOne)
		{
			if( nextActiveFilter == 0L) nextActiveFilter = myActiveFilterList;
			theActiveFilter = nextActiveFilter;
			nextActiveFilter = (struct ActiveFilterStruct *)nextActiveFilter->listHeader.after;
		 	gotOne = HandleFilterLoop(theActiveFilter);
		 	if( nextActiveFilter == 0L) 
		 		if(firstPass) firstPass = FALSE;
		 		else return;
		 }
	}
}	 	
	 	
 	
/*************************** Patch to 0.1 New Routines ********************/

/***************************** HandleContentClick **************************/

void				HandleContentClick( WindowPtr window, EventRecord *event)
{
	short			theLine, thePart;
	Point			where, mouse, lastClick, cell;
	ControlHandle	control;
	Boolean			doubleClick;
	Rect			r;
	char			theChar;
	
	mouse = event->where;
	where = mouse;
	GlobalToLocal(&where);
	
	if( window == gInfoWindow) InfoContentClick( event);
	if ( window == gFilesWindow)
	{
		LastListClicked = 3;
		doubleClick = LClick(where, event->modifiers, gFileList);	/* LClickLoop returns false  before mouseup */ 
		if (doubleClick)
		{
			if (event->modifiers == 0x1000) HandleInfo();
		}
		else HandleListDrag( gFileList);					/* Custom routine takes control till mouseup */

		if ( ( thePart = FindControl( where, gFilesWindow, &control)) != 0)
		{
			if ( control == gDeleteButton) 
			{
				if ( TrackControl( gDeleteButton, where, 0L))
				{
					SetPt( &cell, 0, 0);
					if( LGetSelect( TRUE, &cell, gFileList))
					{
						while( LGetSelect( TRUE, &cell, gFileList))
							LDelRow( 1, cell.v, gFileList);
					}	
					else if ((**gFileList).dataBounds.bottom != 0)						/* set FilterPipe list to 0 */
						LDelRow( (**gFileList).dataBounds.bottom, 0, gFileList);
				}
			}
		}
	}
	if ( window == gProcessWindow)
	{
		LastListClicked = 4;
		doubleClick = LClick(where, event->modifiers, gProcessList);	/* LClickLoop returns false  before mouseup */ 
		if (doubleClick)
		{		
			;
		}
	}
	if ( window == ftWindow)
	{
		r = ( **gFilterList).rView;
		r.right += 15;
		if( PtInRect( where, &r))
		{
			LastListClicked = 1;
			if ( LClick(where, event->modifiers, gFilterList))
			{
				lastClick = LLastClick( gFilterList);
				theLine = lastClick.v;
				
				if (event->modifiers == 0x0800) HandleConfig();
				else if (event->modifiers == 0x1000) HandleInfo();
			
				else if( (**gFileList).dataBounds.bottom > 0)	/* if there are files to filter */
				{
					HandleIndividualActiveFilter( theLine);	/* install a new ActiveFilter */
					LDelRow( (**gFileList).dataBounds.bottom, 0, gFileList); /* delete file list */
				}
				else 
				{
					ParamText("\pNo files in queue", "\pDrop some on the icon", "\p", "\p");
					NoteAlert(128, (ProcPtr) nil);
				}
			}
			else HandleFilterListDrag( gFilterList);
		}
		else
		{
			LastListClicked = 2;
			if ( LClick(where, event->modifiers, gPipeList))
			{
				lastClick = LLastClick( gPipeList);
				theLine = lastClick.v;
				
				if (event->modifiers == 0x0800) HandleConfig();
				else if (event->modifiers == 0x1000) HandleInfo();
			}
			else HandleListDrag( gPipeList);
		}
		if ( ( thePart = FindControl( where, ftWindow, &control)) != 0)
		{
			if ( control == gDeleteFiltersButton) 
			{
				if ( TrackControl( gDeleteFiltersButton, where, 0L))
				{
					SetPt( &cell, 0, 0);
					if( LGetSelect( TRUE, &cell, gPipeList))
					{
						while( LGetSelect( TRUE, &cell, gPipeList))
							LDelRow( 1, cell.v, gPipeList);
					}	
					else if ((**gPipeList).dataBounds.bottom != 0)						/* set FilterPipe list to 0 */
						LDelRow( (**gPipeList).dataBounds.bottom, 0, gPipeList);
				}
			}
			if ( control == gPipesButton) 
			{
				if ( TrackControl( gPipesButton, where, 0L)) 
				{
					if ((**gPipeList).dataBounds.bottom != 0
					&& (**gFileList).dataBounds.bottom != 0)
					{
						HandlePipeLine();
						LDelRow( (**gFileList).dataBounds.bottom, 0, gFileList); /* delete file list */
					}
					else
					{
						ParamText("\pNo files in queue", "\por no pipe line", "\p", "\p");
						NoteAlert(128, (ProcPtr) nil);
					}
				}
			}
		}
	}
}
 	

/********************************** HandleConfig **********************/

OSErr		HandleConfig()
{
	short		theLine, pipeInfoLength;
	Point		cell;
	ListHandle	list;
	PipeInfo	myPipeInfo;

	if(	LastListClicked == 1) list = gFilterList;
	else if( LastListClicked == 2) list = gPipeList;
	else return -1;

	
	SetPt( &cell, 0, 0);
	if( LGetSelect( TRUE, &cell, list))
	{
		if( list == gFilterList) theLine = cell.v;
		else
		{
			cell.h = 1;
			pipeInfoLength = sizeof(myPipeInfo);
			LGetCell( &myPipeInfo, &pipeInfoLength, cell, gPipeList);		/* insert short in new cell */
			theLine = myPipeInfo.filterNumber;
		}
		if( filters[theLine].fINFrec.configPossible == 0x00000001)
				ConfigureFilter( theLine);
	}
	return noErr;
}

/********************************** MyOpenFile **********************/

Boolean		MyOpenFile( FSSpec *myFSS)
{
	Point	cell;
	char	line[63];
	short	i, fRef;
	OSErr	err;
	FInfo	fndrInfo;
	Boolean	targetIsFolder, wasAliased;

	err = ResolveAliasFile( myFSS, TRUE, &targetIsFolder, &wasAliased);
	if (err != noErr) return 0;
	
	FSpGetFInfo( myFSS, &fndrInfo);
	if( fndrInfo.fdCreator == 'fSTB')
	{
		if( fndrInfo.fdType == 'APPL') 
			LoadPipeLine( myFSS);
			return 0;
	}

	if( fndrInfo.fdCreator == 'fFLT')
	{
		if( fndrInfo.fdType == 'APPL') 
			LoadSingleFilter( myFSS);
			return 0;
	}

	if( targetIsFolder) /* found a folder */
		MyOpenFolder( myFSS);
	else AddLineToList( gFileList, myFSS);

	return 0;
}

/********************************** MyOpenFolder **********************/
 void			MyOpenFolder( FSSpec *myFSS)
{
 	long		dirID;
	short		index;
	HFileInfo	myCPB;
	OSErr		myErr = noErr;
	FSSpec		newFSS;
	
	myCPB.ioVRefNum = 0;
	myCPB.ioFDirIndex = 0;
	myCPB.ioNamePtr = (StringPtr)&myFSS->name;
	myCPB.ioDirID = myFSS->parID;
	myErr = PBGetCatInfo((CInfoPBPtr) &myCPB, FALSE);
	dirID = myCPB.ioDirID;
	if( myErr != noErr)
	{
		SysBeep( 10);
		return;
	}
	myCPB.ioNamePtr = (StringPtr) NewPtrClear(40L);
	index = 1;
	myErr = noErr;
	while( myErr == noErr)
	{
		myCPB.ioFDirIndex = index;
		myCPB.ioNamePtr[0] = 0;
		myCPB.ioDirID = dirID;
		myErr = PBGetCatInfo((CInfoPBPtr) &myCPB, FALSE);
		if( myErr == noErr) 
		{
			FSMakeFSSpec( 0L, dirID, myCPB.ioNamePtr, &newFSS);
			AddLineToList( gFileList, &newFSS);
		}
		index += 1;
	}
	DisposePtr( (Ptr) myCPB.ioNamePtr);
}

/************************************* DoAbout ***************************/

void		DoAbout()
{
	EventRecord			theEvent;
	DialogPtr			theDialog;
	PicHandle			thePic;
	Rect				r;
	short				wide, high;
	GrafPtr				oldPort;
	
	GetPort (&oldPort);

	if ( theDialog = GetNewDialog (405, 0L, (WindowPtr)-1L) )
	{
		SetPort( theDialog );
	
		zoomport (theDialog, 1);
		ShowWindow( theDialog );
		
		DrawDialog( theDialog );
		
		/* wait for a key or mouse down */
		while (!GetNextEvent (keyDownMask + mDownMask, &theEvent))
			SystemTask();
			
		thePic = GetPicture( 406);
		if(thePic != 0)
		{
			r = (*thePic)->picFrame;
			wide = r.right - r.left;
			high = r.bottom - r.top;
			SetRect(&r, 3,3,wide,high);
			EraseRect( &theDialog->portRect);
			DrawPicture(thePic,&r);
			Delay( 120L, 0L);
		}
		zoomport( theDialog, 0);
		DisposDialog (theDialog);
		
		SetPort( oldPort );
	}
}


