/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	myString.c

NAME
	myString.c for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles configuring filters.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/****************************** myString.c *******************************/

/************************** includes */

#include	"myString.h"

/*********************************** pStrcpy ***************************/
/* Copy Pascal String, returns destination string */

char 		*pStrcpy( char *s, char *t)
{
	short	tLen;

	for (tLen = *t + 1; tLen--; s[tLen] = t[tLen]);
	return (s);
}


/*********************************** PStrCompare ***************************/
/* case insensitive string compare, returns true if same */

Boolean	PStrCompare( char *str1, char *str2)
{
	Boolean	result;
	
	asm {
		move.l	str1,a0
		move.l	str2,a1
		moveq	#0,d1
		move.b	(a0)+,d1				;compare two string lengths
		cmp.b	(a1)+,d1
		bne.s	@false
		tst.b	d1
		beq.s	@true					;zero length strings return true
		subq	#1,d1
	@1	move.b	(a0)+,d0				;compare the strings until done
		and.b	#0x5f,d0				;quick and dirty conversion to upper case
		move.b	(a1)+,d2
		and.b	#0x5f,d2
		cmp.b	d2,d0
		bne.s	@false
		dbra	d1,@1
	@true
		move.b	#true,result
		bra.s	@2
	@false
		move.b	#false,result
	@2	
		}
	return( result);
}


/******************************** Doug's String Stuff ****************************/

/*------- 1992 Douglas Yarrington :) ---------*/

char mystrchr(const char *s, short c)
{
	// Check for char c within charcter set s,
	// if found, return c, if not return 0.
	while (*s)
	{
		if ( *s == (char)c)
			return (char)c;
		s++;
	}
	return 0;
}

/*------- 1992 Douglas Yarrington :) ---------*/

long mystrtol(const char *nptr, short len)
{
	long result=0;
	short i, sign=1, gotfirstnum=0;
	
	// Read from left to right
	// Skip lead blanks, recognize -/+
	// Look for first lead num, go until next non num
	for (i=0; i<len; i++)
	{
		if (!gotfirstnum && (nptr[i]=='-'))
		{
			sign = -1;
			gotfirstnum = 1;
		}
		if ( gotfirstnum && (nptr[i]<'0' || nptr[i]>'9'))
			return (result);
		if (nptr[i]>='0' && nptr[i]<='9')
		{
			if (!gotfirstnum)	gotfirstnum = 1;
			result *= 10;
			result += (long)(nptr[i] - '0');
		}
	}
	
	return (result);
}


