/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	prefs.c

NAME
	prefs.c for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles ftEngine prefs.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	New File
	
*/	

/****************************** prefs.c *******************************/

/************************* includes */

#include	"prefs.h"

/************************ Globals */

FSSpec	spec;

/********************************* GetPrefSpec ********************************/

OSErr	GetPrefSpec()
{
	short			err, vRef, fRef;
	long			dirID;
	
	err = FindFolder( kOnSystemDisk, kPreferencesFolderType, kDontCreateFolder, &vRef, &dirID);
	if( err == noErr) FSMakeFSSpec( vRef, dirID, "\pftEngine.prefs", &spec);	
	else return err;
	err = FSpOpenRF( &spec, fsCurPerm, &fRef);
	if( err == fnfErr)  FSpCreateResFile( &spec, 'fENG', 'fPRF', -1);
	else FSClose( fRef);
	err = ResError();	
	return err;
}

/******************************* OpenPrefsFile ********************************/

OSErr	OpenPrefsFile( short *fRef)
{
	*fRef = FSpOpenResFile( &spec, fsCurPerm);
	return( ResError());
}


/******************************* Window Pos and Size Prefs *********************/
/******************************* Window Pos and Size Prefs *********************/
/******************************* Window Pos and Size Prefs *********************/

/****************************** GetWindowPref *********************************/

void	GetWindowPref(Rect *window, Point *topLeft, short rID) 
{			
	WinPrefHandle	windowsH;
	short			err, fRef;
	
	err = OpenPrefsFile( &fRef);
	if( err == noErr && fRef != -1)		
	{
		windowsH = (WinPrefHandle)GetResource( 'fWPR', rID);	
	
		if(  windowsH != 0L ) 	/* prefs are already there */
		{			
			*window = (**windowsH).windowRect;
			*topLeft = (**windowsH).topLeft;
		}		
		else 	/* if no prefs, create prefs resource & initialize it */
		{			
			windowsH = (WinPrefHandle)NewHandle( sizeof( WinPrefRec ) );
			
			(**windowsH).windowRect = *window;
			(**windowsH).topLeft = *topLeft;
	
			AddResource( (Handle)windowsH, 'fWPR', rID, "\p" );
			if( ResError() == noErr )
				WriteResource( (Handle)windowsH );
		}
		CloseResFile( fRef);
	}
}

/******************************* SetWindowPref *****************************/

void	SetWindowPref(Rect *windowRect, Point *topLeft, short rID) 
{			
	WinPrefHandle	windowsH;
	short			err, fRef;
	
	err = OpenPrefsFile( &fRef);
	if( err == noErr && fRef != -1)		
	{
		windowsH = (WinPrefHandle)GetResource( 'fWPR', rID);	
		if(!windowsH) 
		{
			CloseResFile( fRef);
			return;
		}
		(**windowsH).windowRect = *windowRect;
		(**windowsH).topLeft = *topLeft;
	
		ChangedResource((Handle)windowsH);
		if (ResError()==noErr)
			WriteResource ( (Handle)windowsH );
	}
	CloseResFile( fRef);
}