/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Steve J in early 1992
	See the Modification History for more details

FILE
	defs.h

NAME
	defs.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code for defines in FilterTop.c.

MODIFICATION HISTORY
	Created by Steve J

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** defs.h ******************************/

/********** General ID's *******************/

#define DEFAULT_ID					1000	/* default resource ID */
#define HELP_BASE_ID				130		/* STR# ID for Help Menu String */
#define FT_HM_ITEMS					5		/* number of strings in above resource */

#define SAVE						2		/* for buttons in dialogs */
#define CANCEL						1

#define FT_HELP_DLG_ID				2000
#define BUILD_SUPERFILTERS_DLG_ID	2001
#define SETTING_FILTER_OPTS_DLG_ID	2002
#define SHORTCUTS_DLG_ID			2003
#define TOPSOFT_DLG_ID				2004

/************* Dialog ID's *****************/

#define GENERAL_PREFS_ID			500
#define NOTIFICATION_PREFS_ID		501
#define FILE_CREATION_PREFS_ID		502
#define PROGRESS_DIALOG_ID			503
#define	PROCESS_PRIORITY_ID			504

/************* Menu ID's *******************/

#define APPLE_MENU					1000
#define FILE_MENU					1001
#define EDIT_MENU					1002
#define FILTERS_MENU				1004
#define	WINDOW_MENU					1005
#define PREFS_SUBMENU				100

/************* Apple Menu ******************/

#define ABOUT_FILTERTOP				1
#define SET_PROCESS_PRIORITY		3

/************** File Menu ******************/

#define NEW_SUPERFILTER				1
#define OPEN						2
#define CLOSE						3
#define SAVE_ITEM					4
#define	SAVE_AS						5
#define REVERT						6
#define TRANSFORM_FILE				7
#define GET_INFO					8
#define PUBLISH						10
#define SUBSCRIBE					11
#define PAGE_SETUP					13
#define PRINT						14
#define	QUIT						16

/************** Edit Menu ******************/

#define UNDO						1
#define CUT							3
#define	COPY						4
#define PASTE						5
#define CLEAR						6
#define SELECT_ALL					8
#define ATTACH_FOLDER				11

/************** Prefs Submenu **************/

#define GENERAL						1
#define NOTIFICATION				2
#define FILE_CREATION				3

/************** Filters Menu ***************/

#define SET_DEFAULT_OPTIONS			1
#define REDIRECT_OUTPUT				3
#define INTELLIGENCE				4

/************** Window Menu ****************/

#define FILTERTOP					1

/************** Help Menu *******************/

#define FILTERTOP_HELP				5
#define BUILDING_SUPERFILTERS		6
#define SETTING_FILTER_OPTIONS		7
#define SHORTCUTS					8
#define ABOUT_TOPSOFT				9

/************** General Prefs Dialog ********/

#define SHOW_PROGRESS_WINDOW		3
#define	PROCESS_RECURSIVELY			4
#define DELETE_ORIGINAL				5
	
/*********** Notification Prefs Dialog ******/

#define NOP_NOTHING					5
#define DONE_NOTHING				9
#define NOP_BEEP					6
#define DONE_BEEP					10
#define NOP_ICON_FLASH				7
#define DONE_ICON_FLASH				11
#define NOP_ALERT					8
#define DONE_ALERT					12

/*********** File Creation Prefs Dialog *****/

#define ASK_NEW_NAME				4
#define SKIP						5
#define ALWAYS_ASK_NAME				6
#define CREATE_UNIQUE_NAME			7
#define	OVERWRITE_FILES				8

/*********** Process Priority Dialog ********/

#define SLEEP_TE					5