/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley, Peter Lewis and Doug Yarrington
	 in early 1992.
	See the Modification History for more details

FILE
	filter.h

NAME
	filter.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code for prototypes that handles the
	filter interface.

MODIFICATION HISTORY
	Created by Chris Priestley, Peter Lewis & Doug Yarrington

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** Cursors.h ******************************/

#ifndef	_filter_
#define	_filter_

/******************************** Defines ***********************/

// Messages sent to the filter
#define msgOpenFilter           1000 // tell filter to initialize itself
#define msgCloseFilter          1010 // tell filter to finish
#define msgStartFiltering       2000 // when we start on a new file
#define msgFinishFiltering      2010 // reached end of input
#define msgFilterAWhile         2100 // filter should work for a time
#define msgAbortFiltering       2200 // user canceled
#define msgInitOptions          2300 // self-config start
#define msgDialogEvent          2310 // self-config handle DLOG event
#define msgCloseOptions         2320 // self-config clean up
#define msgRankThis             2340 // intelligent-filtering

/***************************** Return Codes for Filters *****************/

#define inProgress				1
#define errUnknownMessage		666     // it's the SIGN of _the_ BEAST!!!!
#define fileNotFound			667


/********************************* Peters typedefs ************************/

// Stream definitions
typedef long Stream;

// Callback structure definitions
typedef struct 
{
        pascal OSErr (*GetFSSpec) (FSSpec *spec, OSType *creator, OSType *type);
        pascal OSErr (*SetFSSpec) (short path, FSSpec *spec, OSType *creator, OSType *type);
        pascal long (*StreamAvaibleInputBytes)(Stream strm);
        pascal OSErr (*StreamOpenIn) (Stream *strm, FSSpec *spec, OSType *creator, OSType *type);
        pascal OSErr (*StreamCloseIn) (Stream *strm);
        pascal OSErr (*StreamReadBytes)(Stream strm, void *bufferP, long *noBytes);
        pascal OSErr (*StreamReadUpTo)(Stream strm, void *bufferP, long *noBytes, char upto, short *gotchar);
        pascal OSErr (*StreamOpenOut) (Stream *strm, short path, FSSpec *spec, OSType creator,OSType type);
        pascal OSErr (*StreamCloseOut) (Stream *strm); // Changed to *strm
        pascal OSErr (*StreamWriteBytes)(Stream strm, const void *bufferP, long noBytes);
        pascal OSErr (*StreamWriteString)(Stream strm, Str255 s);
		pascal void (*cfgFindData)(Handle fCFGh, OSType type, char *data, long *dataLen );
} CallBacks;

// ParameterBlock definition, used by filter to access functions in FT shell
typedef struct
{
        long serviceRequested;
        long filterShellVersion;
        CallBacks *cb;
        DialogPtr dlg;
        EventRecord *event;
        Handle filterGlobalsH;   // globals for this filter across all files
        Handle filterConfigH;
        Handle filterVarsH;      // globals for this filter and this file
        Stream streamIn;
        Stream streamOut;
        long var1,var2,var3,var4,var5;
        
} PBCallToFilter, *PBCalltoFilterPtr;


#endif