/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was written by Tony Jacobs in early 1992
	See the Modification History for more details

FILE
	infoManager.h

NAME
	infoManager.h Part of the FilterTop project

DESCRIPTION
	This source file contains code for prototypes that handle the Info Manager.

MODIFICATION HISTORY
	Created by Tony Jacobs

	dd mmm yy	-	xxx	-	patchxx: description of patch
	28 Mar 92	-	CRP	-	Added GetFSSpecFromList proto and PipeInfo typedef
	
*/	

/*********************************** infoManager.h ******************************/

#ifndef	_infoManager_
#define	_infoManager_

/******************** typedefs */

typedef struct {
	short	filterNumber;	
	short	filterType;
}	PipeInfoRec;

/******************** protos */

void			HandleInfo(void);

/******************** window handlers */

void	SetupInfoWindow(void);
void	UpdateInfoWindow(void);
void	ActivateInfoWindow( Boolean);
void	InfoContentClick( EventRecord *);

/******************** utility protos */

OSErr			GetFSSpecFromLastListClicked( FSSpec *);
OSErr			GetFilterInfoHandle( FSSpec, fINFrecord *);
OSErr			GetHFileInfo(FSSpec, HFileInfo *);
void			SetUpDroponableButton ( WindowPtr);


#endif
