/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	stubApp.h

NAME
	stubApp.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code for prototypes that handle
	saving pipeLines, creating stub apps and loading pipeLines from stubs.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	New File
	
*/	

/*********************************** stubApp.h ******************************/

#ifndef	_superFilter_
#define	_superFilter_

/****************** typedefs */

typedef struct				
{							
	unsigned long 	AutoProcess : 1;	
	unsigned long	reserved1 : 1;	
	unsigned long	reserved2 : 1;	
	unsigned long	reserved3 : 1;	
	unsigned long	reserved4 : 1;	
	unsigned long	reserved5 : 1;	
	unsigned long	reserved6 : 1;	
	unsigned long	reserved7 : 1;
		
} fSTUBrec, *fSTUBrecPtr;

typedef struct {	/* This struct will be added too when we progress to superFilters */
	FSSpec	spec;
} sFilterRec, *sFilterRecPtr, **sFilterRecH;

/******************** protos */

OSErr			SavePipeLine( void);							/* PipeLine Stubs */
OSErr			GetNextPipeFilter(short, short, sFilterRec *);
OSErr			LoadPipeLine( FSSpec *);
OSErr			LoadSingleFilter( FSSpec *);
OSErr			CopyResources(short, short);

OSErr			ConvertSingleFilterToApp( FSSpec *, short);		/* Filter Stubs */
OSErr			CopySingleFilterResources( short, short);		
OSErr 			AddSingleResource( short, short, ResType, short);
OSErr			DeleteSingleFilterResources( short);
OSErr 			DeleteSingleResource( short, ResType, short);

void			PutFile(StandardFileReply *);					/* Custom PutFile Dialog */
pascal short	MyStubDlg( short, DialogPtr, Ptr);

#endif


