/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	windowUtils.h

NAME
	windowUtils.h for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles the cursor.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/*********************************** windowUtils.h ******************************/

#ifndef	_windowUtils_
#define	_windowUtils_

#define	squareButProc	80

typedef struct {
	short	filterNumber;	
	short	filterType;
}	PipeInfo;


void			FileWindowSetup( void);
void			ProcessWindowSetup( void);
void			FilterListSetup( void);
void			SetUpListRect( WindowPtr, Rect *);
void			AdjustFilterRects( void);
void			SetUpDeleteButton( WindowPtr );
void			SetUpFilterButtons ( WindowPtr );
void			AdjustWindowItems( WindowPtr);
void			AddLineToList( ListHandle, FSSpec *);
void			AddLineToFilterList( ListHandle, FSSpec *);
void			DrawList( ListHandle);
pascal Boolean	myLClikLoop( void);
void			HandleFilterListDrag( ListHandle);
void			HandleListDrag( ListHandle);
void			ShufflePipeList( Cell, Cell, ListHandle);
void			ShuffleFileList( Cell, Cell, ListHandle);
void			HandleListItemSelect( ListHandle);
void			HandleFilterLineSelect( short);
void			AddLineToPipeList(ListHandle, Str255);

void 			RestoreWindowPos( WindowPtr window, short rID);
void			SaveWindowPositions( void);
void 			SaveWindowPos( WindowPtr window, short rID);

#endif
