/*
Copyright  1991-1992.  All rights reserved.
	

	You may distribute under the terms of either the GNU General Public
	License or the Artistic License, as specified in the README file.
	
	This file was developed by the FilterTop development team, specifcally 
	this file was written by Chris Priestley in early 1992
	See the Modification History for more details

FILE
	filtersLDEF.c

NAME
	filtersLDEF.c for ftEngine. Part of the FilterTop project

DESCRIPTION
	This source file contains code that handles the filters List.

MODIFICATION HISTORY
	Created by Chris Priestley

	dd mmm yy	-	xxx	-	patchxx: description of patch
	25 Mar 92	-	CRP	-	No Changes
	
*/	

/* FiltersLDEF.c : Set the Project Type ID to 130 and name to FiltersLDEF */

void			DoDraw( short, Boolean, Rect *, Cell, short, short, ListHandle);
void			DoInit( short, Boolean, Rect *, Cell, short, short, ListHandle);
void			DoHilite( short, Boolean, Rect *, Cell, short, short, ListHandle);

void			DrawICS( Rect, short, ListHandle);

/***************************** main ***********************/

pascal void		main( message, select, rect, cell, offset, length, list)
short			message;
Boolean			select;
Rect			*rect;
Cell			cell;
short			offset;
short			length;
ListHandle		list;
{
	short		oldFont, oldSize;
	long		savedA5;
	GrafPtr		oldPort;

	savedA5 = SetCurrentA5();
	GetPort( &oldPort);
	SetPort( ( **list).port);
	oldFont = ( **list).port->txFont;
	oldSize = ( **list).port->txSize;
	
	switch (message)
	{
		case lInitMsg:
			DoInit( message, select, rect, cell, offset, length, list);;
			break;

		case lDrawMsg:
			DoDraw( message, select, rect, cell, offset, length, list);
			break;

		case lHiliteMsg:
			DoHilite( message, select, rect, cell, offset, length, list);
			break;

		case lCloseMsg:
			;
			break;
	}
	
	TextFont( oldFont);
	TextSize( oldSize);
	SetA5( savedA5);
}

/****************************** DoInit ***************************/

void		DoInit( message, select, rect, cell, offset, length, list)
short			message;
Boolean			select;
Rect			*rect;
Cell			cell;
short			offset;
short			length;
ListHandle		list;
{
	Point		where;
	FontInfo	info;
	
	GetFontInfo( &info);
	(**list).indent.v = info.ascent;
	(**list).indent.h = 4;				/* arbitrary */
}

/****************************** DoHilite ***************************/

void		DoHilite( message, select, rect, cell, offset, length, list)
short			message;
Boolean			select;
Rect			*rect;
Cell			cell;
short			offset;
short			length;
ListHandle		list;
{
	HiliteMode = HiliteMode & 0x10000000;
	InvertRect( rect);
}

/****************************** DoDraw ***************************/

void		DoDraw( message, select, rect, cell, offset, length, list)
short			message;
Boolean			select;
Rect			*rect;
Cell			cell;
short			offset;
short			length;
ListHandle		list;
{
	Point		where;
	short		lockState;
	Rect		iconRect;
	Handle		iconHandle;
	BitMap		iconMap;
	short		filtNum, shortSize = sizeof(short), resID;
	Cell		myCell;
	
	where.h = rect->left;
	where.v = rect->top;
	AddPt( ( **list).indent, &where);
	MoveTo( where.h + 20, where.v);
	PenNormal();
	lockState = HGetState( ( **list).cells);
	HLock( ( **list).cells);
	EraseRect( rect);
	TextFont( ( **list).port->txFont);
	TextSize( ( **list).port->txSize);
	
	/* ready to roll */
	myCell.v = cell.v;
	myCell.h = 1;
	LGetCell( &filtNum, &shortSize, myCell, list);	/* get the filter Type */
	if( filtNum == 1) resID = 130;
	else if( filtNum == 2) resID = 131;
	else if( filtNum == 3) resID = 132;
	else if( filtNum == 4) resID = 129;
	
	iconRect = *rect;
	iconRect.left += 4;
	iconRect.top += 1;
	iconRect.bottom = iconRect.top + 16;
	iconRect.right = iconRect.left + 16;
	
	DrawICS( iconRect, resID, list);
	DrawText( *( **list).cells, offset, length);
	
	/* finished */
	
	HSetState(  ( **list).cells, lockState);
	if( select)
	{
		HiliteMode = HiliteMode & 0x10000000;
 		InvertRect( rect);
 	}
}


	