/* 
==========================================================================
     AddSuffix.c
     
     Remember to set the fINF resource of the filter to 
     usesStreams bit set to 0.
     usesFSSpecs bit set to 1.
     
     I would also give it a iconNumber of 4 in the fINF resource.
     That way it gets a nice "one to same" icon :)
     ie) one file in, same file out.
     
==========================================================================
*/


#include "filter.h"

short 			cfgSelfInit (PBCallToFilter *);
short 			cfgSelfHandleEvent (PBCallToFilter *);
short 			cfgSelfClose (PBCallToFilter *);

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr     	oe, ooe;
	OSType		creator, ftype;
	FSSpec		fs, newFS;
	FInfo		fileInfo;
	short		path, i;
	char		*dstName;

	oe = noErr;
	path = 1;
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:     // Set up filterGlobalsH 
			break;

		case msgCloseFilter:       // Destroy filterGlobalsH
			break;

		case msgStartFiltering:
			oe = pb->cb->GetFSSpec(&fs, &creator, &ftype);
			if (oe == noErr)
			{
				newFS = fs;
				dstName = (char *)*pb->filterConfigH;	/* grab the config handle */
				for( i = 1; i <= dstName[0]; ++i)
					newFS.name[++(newFS.name[0])] = dstName[i];
				oe = FSpRename( &fs, newFS.name);
				oe = pb->cb->SetFSSpec( path, &newFS, &creator, &ftype);
			}
			oe = noErr;	/* return noErr to finish immediately. Go on to next file */
			break;

		case msgFinishFiltering:
			break;

		case msgFilterAWhile:
			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			cfgSelfInit(pb);
			break;
		
		case msgDialogEvent:
			pb->var5 = cfgSelfHandleEvent (pb);
			break;

		case msgCloseOptions:
			cfgSelfClose(pb);
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


/********************************** Self Configuration ******************************/
/********************************** Self Configuration ******************************/
/********************************** Self Configuration ******************************/

/*--------- Typedefs -----------*/

typedef short state;
#define	cfgStNone	0
#define cfgStOk		1
#define cfgStCancel	2
#define cfgStSave	3

/****************************** cfgSelfInit *********************************/

short 			cfgSelfInit (PBCallToFilter *pb)
{
	short	iType;
	Handle	iHandle;
	Rect	iRect;
	
	SetPort(pb->dlg);
	GetDItem(pb->dlg, 4, &iType, &iHandle, &iRect);
	SetIText( iHandle, (StringPtr)*pb->filterConfigH);
	SelIText( pb->dlg, 4, 0, 32767);
	ShowWindow ( pb->dlg );
}

/****************************** cfgSelfHandleEvent *********************************/

short cfgSelfHandleEvent (PBCallToFilter *pb)
{
short			itemHit,iType;
ControlHandle	iHandle;
DialogPtr		whichD, theD;
EventRecord		*evt;
char 			theChar;
Rect			iRect;
Point			where;
Cursor			editCursor;
CursHandle		curH;


	theD = pb->dlg;
	evt = pb->event;
	where = evt->where;
	GlobalToLocal(&where);

	switch (evt->what) 		/* keyboard support */
	{
		case keyDown:
			theChar = evt->message & charCodeMask;
			if ((theChar==0x03) || (theChar==0x0D)) 
			{
				long	d;
				GetDItem ( theD, 1, &iType, (Handle *)&iHandle, &iRect );
				HiliteControl ( iHandle, 1 );
				Delay(2,&d);
				HiliteControl ( iHandle, 0 );
				return cfgStOk;
			}
		break;
		
		case updateEvt:
			GetDItem(pb->dlg, 1, &iType, (Handle *)&iHandle, &iRect);
			PenSize(3,3);
			InsetRect(&iRect, -4, -4);
			FrameRoundRect(&iRect, 16, 16);
	}
	
	if( FindDItem ( theD, where ) == 3 )	/* Cursor Control */
	{
		curH = GetCursor( iBeamCursor);
		editCursor = **curH;
		SetCursor( &editCursor);
	}
	else
		InitCursor();

	if ( DialogSelect ( evt, &whichD, &itemHit ) ) 
		if (whichD == theD)
		{
			switch (itemHit)
			{
				case 1:
					return cfgStOk;
				break;

				case 2:
					return cfgStCancel;
				break;

				case 3:
					return cfgStSave;
				break;
				
			}
		}

	return cfgStNone;

}

/****************************** cfgSelfClose *********************************/

short 			cfgSelfClose (PBCallToFilter *pb)
{
	short	iType, i;
	Handle	iHandle;
	Rect	iRect;
	
	if(pb->var5 == cfgStOk || pb->var5 == cfgStSave)
	{
		GetDItem(pb->dlg, 4, &iType, &iHandle, &iRect);
		
		if( GetHandleSize( pb->filterConfigH) != sizeof(Str255) )
			SetHandleSize( pb->filterConfigH, sizeof(Str255));
		
		HLock( (Handle)pb->filterConfigH);
		GetIText( iHandle, (StringPtr)*pb->filterConfigH);
		HUnlock( (Handle)pb->filterConfigH);
	}
}



