/* 
==========================================================================
     Append to File.c
     
     Remember to set the fINF resource of the filter to 
     usesStreams bit set to 1.
     usesFSSpecs bit set to 0.
     
     I would also give it a iconNumber of 2 in the fINF resource.
     That way it gets a nice "many to one" icon :)
     ie) many files in, one file out.
     
==========================================================================
*/


#include "filter.h"

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr				oe;
	OSType				creator, ftype;
	FSSpec 				fs;
	long				count;
	short				refNum;
	char				inBuffer[512];
    StandardFileReply 	reply;
	SFTypeList			TypeList;

	oe = noErr;	
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:
			break;

		case msgCloseFilter:
			break;

		case msgStartFiltering:		
			pb->var1 = 0L;
			TypeList[0] = 'TEXT';
			StandardGetFile(nil, 1, TypeList, &reply); 
			if (reply.sfGood)
			{
				oe = FSpOpenDF( &reply.sfFile, fsRdWrPerm, &refNum);	/* open append file */
				oe = SetFPos( refNum, fsFromLEOF, 0);					/* move to end of file */
				pb->var1 = refNum;
				oe = inProgress;
			}
			else oe = noErr;	/* finish immediately */
			break;

		case msgFinishFiltering:
			refNum = pb->var1;
			FSClose( refNum);		/* close append file */
			break;					

		case msgFilterAWhile:
			refNum = pb->var1;
			
			if( pb->streamIn == 0L)	/* if no openIn stream */
			{ 
				oe = pb->cb->StreamOpenIn( &pb->streamIn, &fs, &creator, &ftype);
				if( oe == noErr)
				{
					oe = pb->cb->StreamOpenOut( &pb->streamOut, 1, &fs, creator, ftype);
					oe = inProgress;
				}
				else if( oe == inProgress) break;	/* none available at the moment */
				else if( oe == -1)					/* none left at all */
				{
					oe = noErr;						/* finish immediately */
					break;
				}	
			}
			
			count = 512;
			if(( oe = pb->cb->StreamReadBytes( pb->streamIn, inBuffer, &count)) == noErr)
			{
				oe = pb->cb->StreamWriteBytes( pb->streamOut, inBuffer, count);	/* write out to stream */
				oe = FSWrite( refNum, &count, inBuffer);						/* write out to append file */	
				oe = inProgress;
			}
			else
			{
				oe = pb->cb->StreamCloseIn( &pb->streamIn);	/* finished with that stream */
				oe = pb->cb->StreamCloseOut( &pb->streamOut);
				pb->var1 = 0L;
				pb->var2 = 0L;
				oe = inProgress;	/* keep going in case there is another stream */								
			}

			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


