#include "filter.h"


/*************** protos for filter's internal use *********************/

OSErr		HandleFile( FSSpec *, short);
Boolean		AddFSSToAEList( AEDescList *, short, FSSpec *);
Boolean		FindAProcess( OSType, ProcessSerialNumber *, ProcessInfoRec *, FSSpec *);
Boolean		DoCatSearch(FSSpec *, OSType, OSType);
void		PrepareToLaunch(AppleEvent *, AEDesc *, LaunchParamBlockRec *);

/************************** main *****************************/

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr     			oe, ooe, err;
	OSType				fType,
						fCreator,
						ExpandCreator;
	SFTypeList			appTypeList;
    StandardFileReply 	myAppReply;
    AppleEvent 			theEvent, theReply;
 	AEAddressDesc		targetAddress;
    AliasHandle 		fileAlias;
    AEDescList 			fileList;
	ProcessSerialNumber	process;
	ProcessInfoRec		infoRec;
	FSSpec				myFSSpec, fs;
    LaunchParamBlockRec launchThis;
    AEDesc				launchDesc;


	oe = noErr;						/* oe is returned to FT on each call */
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:     // Set up filterGlobalsH 
			break;

		case msgCloseFilter:       // Destroy filterGlobalsH
			break;

		case msgStartFiltering:
			oe = inProgress;
			break;

		case msgFinishFiltering:
			break;				

		case msgFilterAWhile:
			oe = pb->cb->GetFSSpec(&fs, &fCreator, &fType);			/* grab the next FSSpec */
			if( oe == noErr)
			{
				ExpandCreator = 'SITx';
				if( fCreator == 'SIT!' || fCreator == 'CPCT' || fCreator == 'GEOL')
				{
					if( FindAProcess( ExpandCreator, &process, &infoRec, &myFSSpec) )
					{
						err = AECreateDesc( typeProcessSerialNumber, (Ptr)&process, sizeof( ProcessSerialNumber), &targetAddress);
						err = AECreateAppleEvent(kCoreEventClass, kAEOpenDocuments, &targetAddress, kAutoGenerateReturnID, kAnyTransactionID, &theEvent);
						err = AEDisposeDesc (&targetAddress);
						err = AECreateList(nil, 0, false, &fileList);
						err = AddFSSToAEList( &fileList, 1, &fs);
						err = AEPutParamDesc(&theEvent, keyDirectObject, &fileList);
						err = AESend ( &theEvent, &theReply, kAENoReply, kAEHighPriority, kNoTimeOut, 0L, nil);
						err = AEDisposeDesc (&theEvent);
						err = AEDisposeDesc ( &theReply);
						err = AEDisposeDesc(&fileList);
					}	
					else if ( DoCatSearch( &myFSSpec, 'SITx', 'APPL'))
					{
						err = AECreateDesc( typeApplSignature, (Ptr)&ExpandCreator, sizeof( ExpandCreator), &targetAddress);
						err = AECreateAppleEvent(kCoreEventClass, kAEOpenDocuments, &targetAddress, kAutoGenerateReturnID, kAnyTransactionID, &theEvent);
						err = AEDisposeDesc (&targetAddress);
						err = AECreateList(nil, 0, false, &fileList);
						err = AddFSSToAEList( &fileList, 1, &fs);
						err = AEPutParamDesc(&theEvent, keyDirectObject, &fileList);
				    	launchThis.launchAppSpec = &myFSSpec;
						PrepareToLaunch(&theEvent, &launchDesc, &launchThis);
					    LaunchApplication(&launchThis);
						HUnlock((Handle)theEvent.dataHandle);
						err = AEDisposeDesc (&theEvent);
						err = AEDisposeDesc ( &theReply);
						err = AEDisposeDesc(&fileList);
					}
					else
					{
						appTypeList[0] = 'APPL';
						StandardGetFile(nil, 1, appTypeList, &myAppReply); if (!myAppReply.sfGood) return; /* grab app */		
						err = AECreateAppleEvent(kCoreEventClass, kAEOpenDocuments, &targetAddress, kAutoGenerateReturnID, kAnyTransactionID, &theEvent);
						err = AECreateList(nil, 0, false, &fileList);
						err = AddFSSToAEList( &fileList, 1, &fs);
						err = AEPutParamDesc(&theEvent, keyDirectObject, &fileList);
				    	launchThis.launchAppSpec = &myAppReply.sfFile;
						PrepareToLaunch(&theEvent, &launchDesc, &launchThis);
					    LaunchApplication(&launchThis);
						HUnlock((Handle)theEvent.dataHandle);
						err = AEDisposeDesc (&theEvent);
						err = AEDisposeDesc ( &theReply);
						err = AEDisposeDesc(&fileList);
					}
				}
				oe = pb->cb->SetFSSpec(1, &fs, &fCreator, &fType);			/* hand file back to FT */
				oe = noErr;	/* return straight away. No inProgress */
			}			
		break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}



/********************************** Utilities *********************************/

/******************************* AddFSSToAEList *****************************/

Boolean		AddFSSToAEList( list, row, spec )
AEDescList	*list;
short		row;
FSSpec		*spec;
{
	OSErr			err;
	AliasHandle		fileAlias;
	
 	err = NewAlias(nil, spec, &fileAlias);
	HLock((Handle)fileAlias);
	err = AEPutPtr( list, row, typeAlias, (Ptr)*fileAlias, (**fileAlias).aliasSize);
	HUnlock((Handle)fileAlias);	
	DisposeHandle((Handle)fileAlias);
}


/******************************* FindAProcess ****************************/

Boolean		FindAProcess( creator, process, infoRec, myFSSpec)
OSType				creator;
ProcessSerialNumber	*process;
ProcessInfoRec		*infoRec;
FSSpec				*myFSSpec;
{
	process->highLongOfPSN = 0;
	process->lowLongOfPSN = kNoProcess;	/* start from the beginning */
	infoRec->processInfoLength = sizeof( ProcessInfoRec);
	infoRec->processName = (StringPtr)NewPtr(32);
	infoRec->processAppSpec = myFSSpec;
	while(GetNextProcess(process) == noErr)
	{
		if(GetProcessInformation(process, infoRec) == noErr)
			if( infoRec->processType == (long)'APPL' 
			&& infoRec->processSignature == creator )
			{
				DisposPtr( (Ptr)infoRec->processName);
				return TRUE;
			}
	}
	DisposPtr( (Ptr)infoRec->processName);
	return FALSE;
}


/****************************** PrepareToLaunch *****************************/

void		PrepareToLaunch(theEvent, launchDesc, launchThis)
AppleEvent			*theEvent;
AEDesc				*launchDesc;
LaunchParamBlockRec *launchThis;
{
	    AECoerceDesc(theEvent, typeAppParameters, launchDesc);
	    /* and stuff it in the parameter block */
	    /* This is a little weird, since we're actually moving the event out of the */
	    /* AppParameters descriptor.  But it's necessary, the coercison to typeAppParameters */
	    /* stuffs the whole appleevent into one AERecord (instead of a AEDesc) so  */
	    /* the Finder gets the whole event as one handle.  It can then parse it itself */
	    /* to do the sending */
		HLock((Handle)theEvent->dataHandle);
	    launchThis->launchAppParameters = (AppParametersPtr)*(launchDesc->dataHandle);
	    /* launch the thing */
	    launchThis->launchBlockID = extendedBlock;
	    launchThis->launchEPBLength = extendedBlockLen;
	    launchThis->launchFileFlags = 0L;
	    launchThis->launchControlFlags = launchContinue + launchNoFileFlags;
}



/******************************* DoCatSearch ****************************/

#define kOneKilobyte 1024

Boolean DoCatSearch(spec, creator, type)
FSSpec	*spec;
OSType	creator, type;
{
	Boolean	result = false; /* assume we won't find it */
	short	i;
	
	short bufferSize = kOneKilobyte * 16; /* I will be using this to make  */
											/* the optimization buffer */
    OSErr myError;	/* general error variable */
	
	/* here I am initializing the cat search parameter block (csBlockPtr) using */
	/* NewPointerClear so I know that all the fields in the parameter block */
	/* will be clear before I start.  This helps prevent errors */
    CSParamPtr csBlockPtr = (CSParamPtr)NewPtrClear(sizeof(CSParam));
	
    long dirIDUnused;	/* for GetVol use */
    Str32 nulString = "\p"; /* an empty string to pass to PBCatSearch */
	
	    /* initialize the parameter block */
    /* first I see if we got the memory we need */
	if (csBlockPtr) {
		/* yes, we have the memory to work.  Build the parameter block */
		
		/* First get the memory for the two other parameter blocks we need */
		/* these blocks are used to give PBCatSearch to exact information */
		/* it needs to match a file */
        csBlockPtr->ioSearchInfo1 = (CInfoPBPtr)NewPtrClear(sizeof(CInfoPBRec));
        csBlockPtr->ioSearchInfo2 = (CInfoPBPtr)NewPtrClear(sizeof(CInfoPBRec));
		/*  check to be sure we got the memory we need */
        if (csBlockPtr->ioSearchInfo1 && csBlockPtr->ioSearchInfo2) {
            /* we have memory */
			/* Now allocate a buffer to hold the result of the PBCatSearch call */
			/* this is an array of ioMatchPtr, which is defined as an FSSpecPtr */
			/* so we will get the size of an FSSpec record  */
			/* I am only asking for one file, so I will only ask for that much memory */
			csBlockPtr->ioMatchPtr = (FSSpecPtr)NewPtrClear(sizeof(FSSpec) * 1);        /* only looking for 1 */
            if (csBlockPtr->ioMatchPtr) {
			/* got the memory for that */
                /* Now see if we can create an optimization buffer */
				/* I will start by asking for a 16K buffer */
				/* If I cannot get that, I will keep reducing my request  */
				/* until I get to zero.  A one  K buffer is better than no  */
				/* buffer at all */
				while(bufferSize){				
                csBlockPtr->ioOptBuffer = NewPtr(bufferSize);
				if(csBlockPtr->ioOptBuffer){
				break;
				} else {
				bufferSize -= kOneKilobyte;
				}
				}
                if (csBlockPtr->ioOptBuffer)
                    csBlockPtr->ioOptBufSize = bufferSize;
                else
                    csBlockPtr->ioOptBufSize = 0;           /* no buffer, sorry */
				/* I want to find one file */
                csBlockPtr->ioReqMatchCount = 1;
				/* No timeout.  PBCatSearch will keep running until it finds */
				/* a file or searches the whole volume */
                csBlockPtr->ioSearchTime = 0;               /* no timeout */
            	/* Change this parameter in a real application.  In a real application, */
				/* you would want to come back periodically (every 2 seconds or so) */
				/* to do various things like; */
				/* 1) Spin a 'wait' cursor */
				/* 2) Update a thermometer bar */
				/* 3) Call WaitNextEvent, so the user can switch out */
				/* of your application while you are searching */
				/* Watch the Finder's "Find" command work so you can see how this */
				/* is done */
			}
        }
    }
	/* This sample only works on the default directory, so I am getting the  */
	/* volume reference number for that volume here */
    csBlockPtr->ioVRefNum = 0;     /* get default volume for search */
	/* make sure these two pointer are clear */
    csBlockPtr->ioSearchInfo1->hFileInfo.ioNamePtr = nil;
    csBlockPtr->ioSearchInfo2->hFileInfo.ioNamePtr = nil;
	
	/* put in the type and creator */
    csBlockPtr->ioSearchInfo1->hFileInfo.ioFlFndrInfo.fdCreator = creator;
	csBlockPtr->ioSearchInfo1->hFileInfo.ioFlFndrInfo.fdType = type;
	
    /* This is the paramter that specifies HOW to search */
	csBlockPtr->ioSearchBits = fsSBFlFndrInfo;
	/* in this case, I am saying to search by Finder information. */
	/* there are MANY values allowed here, and you can also use */
	/* many combinations, as*/
	/*     
	fsSBPartialName	search for partial names
    fsSBFullName	search for full names
    fsSBFlAttrib	""	directory flags
    fsSBFlFndrInfo	Finder info
    fsSBFlLgLen		data fork logical size
    fsSBFlPyLen		dat fork physical size
    fsSBFlRLgLen	resource fork logical size
    fsSBFlRPyLen	resource fork physical size
    fsSBFlCrDat		creation date
    fsSBFlMdDat		modification date
    fsSBFlBkDat		backup date
    fsSBFlXFndrInfo	more finder info
    fsSBFlParID		file parent ID (directory ID)
    fsSBDrUsrWds	directory information
    fsSBDrNmFls		number of files in a folder
    fsSBDrCrDat		folder creation date
    fsSBDrMdDat		""	   mod date
    fsSBDrBkDat		""		backup date
    fsSBDrFndrInfo	finder folder information
 */
	/* and you can combine many of these, to create unique searches */
	
	/* Set up the second search parameter block */
	/* For the search I am doing (creator/filetype) these need to be set to -1 */
    csBlockPtr->ioSearchInfo2->hFileInfo.ioFlFndrInfo.fdCreator = 0xFFFFFFFF;
    csBlockPtr->ioSearchInfo2->hFileInfo.ioFlFndrInfo.fdType = 0xFFFFFFFF;
	/* For other searches (like by modification date) this would indicate the end of the */
	/* search range.  This allows you to, for example, search for all the files  */
	/* modified between October 1 1991 and October 12 1991 */	
	/* Many more combinations are possible, see Inside Mac VI */
	
	/* Search.  I am searching syncronously in this case */
    myError = PBCatSearch(csBlockPtr, false);

	/* See if there were any errors.  Also, see if a file was found */
	/* ioActMatchCount will show how many files were really found if  */
	/* we had asked for more than one */
    if (myError == noErr && csBlockPtr->ioActMatchCount != 0) {
    	for(i = 0; i <= csBlockPtr->ioMatchPtr[0].name[0]; ++i) spec->name[i] = csBlockPtr->ioMatchPtr[0].name[i];
    	spec->vRefNum = csBlockPtr->ioMatchPtr[0].vRefNum;
    	spec->parID = csBlockPtr->ioMatchPtr[0].parID;
        result = true;
    }
    else result = false;
    
    /* no matter what happened, kill the memory we had allocated */
    if (csBlockPtr) {
        if (csBlockPtr->ioSearchInfo1)
            DisposPtr((Ptr)csBlockPtr->ioSearchInfo1);
        if (csBlockPtr->ioSearchInfo2)
            DisposPtr((Ptr)csBlockPtr->ioSearchInfo2);
        if (csBlockPtr->ioMatchPtr)
            DisposPtr((Ptr)csBlockPtr->ioMatchPtr);
        if (csBlockPtr->ioOptBuffer)
            DisposPtr((Ptr)csBlockPtr->ioOptBuffer);
        DisposPtr((Ptr)csBlockPtr);
    }
    
    return result;
    /* catsearch section end */
    
}

