/* 
==========================================================================
     TransformFile.c (Stream version)
     
     Remember to set the fINF resource of the filter to 
     usesStreams bit set to 1.
     usesFSSpecs bit set to 0.
     
     I would also give it an IconNumber of 1 in the fINF resource.
     That way it gets a nice "one to one" icon :)
     ie) one file in, one file out.

==========================================================================
*/


#include "filter.h"

/*************** protos for filter's internal use *********************/

short			ConvertBuffers( char *, char *, long);

/************************** main *****************************/

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr		oe;
	OSType		creator, ftype;
	FSSpec 		fs;
	long		count;
	char		inBuffer[512], outBuffer[512];

	oe = noErr;	
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:
			break;

		case msgCloseFilter:
			break;

		case msgStartFiltering:		
			oe = pb->cb->StreamOpenIn( &pb->streamIn, &fs, &creator, &ftype);
			if( oe == noErr)
			{
				oe = pb->cb->StreamOpenOut( &pb->streamOut, 1, &fs, creator, ftype);
				oe = inProgress;
			}
			break;

		case msgFinishFiltering:
			break;					

		case msgFilterAWhile:
			count = 512;
			if(( oe = pb->cb->StreamReadBytes( pb->streamIn, inBuffer, &count)) == noErr)
			{
				ConvertBuffers( inBuffer, outBuffer, count);				
				oe = pb->cb->StreamWriteBytes( pb->streamOut, outBuffer, count);
				oe = inProgress;
			}
			else
			{
				oe = pb->cb->StreamCloseIn( &pb->streamIn);
				oe = pb->cb->StreamCloseOut( &pb->streamOut);
				oe = noErr;								
			}

			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


/****************************** ConvertBuffers ****************************/
/* this is where the real work is done */
/* source data comes in on the inBuf, put the convsion on the outBuf */
/* the inBuf contains up to 512 chars. The count variable tells you how many */

short		ConvertBuffers( inBuf, outBuf, count)
char		*inBuf, *outBuf;	
long		count;
{
	short	i;
	
	for( i = 0; i < count; ++i)	/* loop thru all chars in inBuf */
	{
		if( inBuf[i] == 10 )	
			outBuf[i] = 13;
		else
			outBuf[i] = inBuf[i];
	}
	return noErr;
}			

/******************************* other sample traslations **********************/
/* insert in the for loop of the ConvertBuffers routine */

/* Convert UpperCase */
/*
		if( inBuf[i] > 96 && inBuf[i] < 123 )	
			outBuf[i] = inBuf[i] - 32;
		else
			outBuf[i] = inBuf[i];
*/


/* Convert LowerCase */
/*
		if( inBuf[i] > 64 && inBuf[i] < 91 )	
			outBuf[i] = inBuf[i] + 32;
		else
			outBuf[i] = inBuf[i];
*/


/* Mac to Unix */
/*
		if( inBuf[i] == 13 )	
			outBuf[i] = 10;
		else
			outBuf[i] = inBuf[i];
*/

/* Unix to Mac */
/*
		if( inBuf[i] == 10 )	
			outBuf[i] = 13;
		else
			outBuf[i] = inBuf[i];
*/