/* 
==========================================================================
     cat.c (Stream version)
     
     Remember to set the fINF resource of the filter to 
     usesStreams bit set to 1.
     usesFSSpecs bit set to 0.
     
     I would also give it an IconNumber of 2 in the fINF resource.
     That way it gets a nice "many to one" icon :)
     ie) many files in, one file out.
     

==========================================================================
*/


#include "filter.h"

pascal OSErr     		main(PBCallToFilter *pb)
{
	OSErr				oe;
	OSType				creator, ftype;
	FSSpec 				fs;
	long				count;
	char				inBuffer[512];
   StandardFileReply 	reply;

	oe = noErr;			
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:
			break;

		case msgCloseFilter:
			break;

		case msgStartFiltering:		
			oe = pb->cb->StreamOpenIn( &pb->streamIn, &fs, &creator, &ftype);
			if( oe == noErr)
			{
				StandardPutFile( "\pName file to concatinate too...", "\p", &reply);
				if (reply.sfGood)
				{
					oe = pb->cb->StreamOpenOut( &pb->streamOut, 1, &reply.sfFile, creator, ftype);
					oe = inProgress;
				}
				else 
				{
					oe = pb->cb->StreamCloseIn( &pb->streamIn);	/* finished with that stream */
					oe = noErr;	/* finish immediately */
				}
			}
			break;

		case msgFinishFiltering:
			if( pb->streamOut != 0L)
				oe = pb->cb->StreamCloseOut( &pb->streamOut);
			break;					

		case msgFilterAWhile:			
			if( pb->streamIn == 0L)	/* if no openIn stream */
			{ 
				oe = pb->cb->StreamOpenIn( &pb->streamIn, &fs, &creator, &ftype);
				if( oe == noErr)
					oe = inProgress;
				else if( oe == inProgress) break;	/* none available at the moment */
				else if( oe == -1)					/* none left at all */
				{
					oe = noErr;						/* finish immediately */
					break;
				}	
			}
			
			count = 512;
			if(( oe = pb->cb->StreamReadBytes( pb->streamIn, inBuffer, &count)) == noErr)
			{
				oe = pb->cb->StreamWriteBytes( pb->streamOut, inBuffer, count);	/* write out to stream */
				oe = inProgress;
			}
			else
			{
				oe = pb->cb->StreamCloseIn( &pb->streamIn);	/* finished with that stream */
				pb->streamIn = 0L;
				oe = inProgress;	/* keep going in case there is another stream */								
			}

			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}

