/* 
==========================================================================
     ChangeCreator.c
     
     Remember to set the fINF resource of the filter to 
     usesStreams bit set to 0.
     usesFSSpecs bit set to 1.
     
     I would also give it a iconNumber of 4 in the fINF resource.
     That way it gets a nice "one to same" icon :)
     ie) one file in, same file out.

==========================================================================
*/


#include "filter.h"

pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr     	oe, ooe;
	OSType		creator, ftype;
	FSSpec		fs;
	FInfo		fileInfo;
	short		path;

	oe = noErr;
	path = 1;
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:     // Set up filterGlobalsH 
			break;

		case msgCloseFilter:       // Destroy filterGlobalsH
			break;

		case msgStartFiltering:
			oe = inProgress;	// Return inProgress so msgFilterAWhile will get called next
			break;

		case msgFinishFiltering:
			break;

		case msgFilterAWhile:
			oe = inProgress;
			oe = pb->cb->GetFSSpec(&fs, &creator, &ftype);
			if (oe == noErr)
			{
				oe = FSpGetFInfo( &fs, &fileInfo );		/* get the FInfo for the file */
				if( oe == noErr)
				{
					creator = fileInfo.fdCreator = 'fENG'; 		/* change creator */		
					oe = FSpSetFInfo( &fs, &fileInfo );	/* set the new FInfo for the file */
					oe = pb->cb->SetFSSpec( path, &fs, &creator, &ftype);		/* new callBack for pipeLine */
				}
			}
			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


