/* 
==========================================================================
     crypt.c (Stream version) Adrian Vansyl 1992
	
	 This version has no configuration and has a hard wired key.
	 
     This filter works both ways.
     If the file is unencrypted, it encrypts it.
     If the file is encrypted, it unencryts it.
     
==========================================================================
*/


#include "filter.h"

/*************** protos for filter's internal use *********************/

short			ConvertBuffers( char *, char *, long);
char 			*cStrcpyn(char *,char *, short);

/************************** main *****************************/
pascal OSErr     main (PBCallToFilter *pb)
{
	OSErr		oe;
	OSType		creator, ftype;
	FSSpec 		fs;
	long		count;
	char		inBuffer[512], outBuffer[512];

	oe = noErr;	
	switch( pb->serviceRequested )
	{
		case msgOpenFilter:
			break;

		case msgCloseFilter:
			break;

		case msgStartFiltering:		
			oe = pb->cb->StreamOpenIn( &pb->streamIn, &fs, &creator, &ftype);
			if( oe == noErr)
			{
				oe = pb->cb->StreamOpenOut( &pb->streamOut, 1, &fs, creator, ftype);
				oe = inProgress;
			}
			else pb->streamIn = 0L;			

			break;

		case msgFinishFiltering:
			break;					

		case msgFilterAWhile:
			
			if( pb->streamIn == 0L)
			{ 
				oe = -1;
				break;
			}
			
			count = 512;
			if(( oe = pb->cb->StreamReadBytes( pb->streamIn, inBuffer, &count)) == noErr)
			{
				ConvertBuffers( inBuffer, outBuffer, count);				
				oe = pb->cb->StreamWriteBytes( pb->streamOut, outBuffer, count);
				oe = inProgress;
			}
			else
			{
				oe = pb->cb->StreamCloseIn( &pb->streamIn);
				oe = pb->cb->StreamCloseOut( &pb->streamOut);
				oe = noErr;								
			}

			break;

		case msgAbortFiltering:
			break;

		case msgInitOptions:
			break;
		
		case msgDialogEvent:
			break;

		case msgCloseOptions:
			break;

		case msgRankThis:
			break;

		otherwise:
			oe = errUnknownMessage;
			break;
	}
	return oe;
}


/****************************** ConvertBuffers ****************************/
short		ConvertBuffers( inBuf, outBuf, count)
char		*inBuf, *outBuf;	
long		count;
{
	short	i, keyoffset, keylength;
	char key[20];
	
	 cStrcpyn( key, "test key number one", 20); /* this is the key used to crypt */
	
	keylength = 19;  /* should be len(key) */
	
	for( i = 0; i < count; ++i)					/* loop thru all chars in inBuf */
	{
		keyoffset = i % keylength;  			/* cycle through all the letters in key */
		outBuf[i] = inBuf[i] ^ key[keyoffset];  /* do an EOR with each char */
	}
	return noErr;
}			


/*********************************** cStrcpyn ***************************/
/* Copy C String, returns destination string */

char     *cStrcpyn(s,t,n)
char    *s, *t;
short 	n;
{
	short   i;

	for (i = 0; i < n && t[i] != '\0'; ++i)  s[i] = t[i];
	s[i] = '\0';
	return (s);
}




